// AlphaChannelOptionsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "tulsa sample app.h"
#include "AlphaChannelOptionsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAlphaChannelOptionsDlg dialog


CAlphaChannelOptionsDlg::CAlphaChannelOptionsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAlphaChannelOptionsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAlphaChannelOptionsDlg)
	m_bHorzGradient = FALSE;
	m_bVertGradient = FALSE;
	m_AlphaValue = 0;
	//}}AFX_DATA_INIT

	m_pCardDlg = NULL;
}


void CAlphaChannelOptionsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAlphaChannelOptionsDlg)
	DDX_Control(pDX, IDC_ALPHA_LEVEL_SLIDER, m_AlphaSlider);
	DDX_Check(pDX, IDC_HORZ_GRADIENT, m_bHorzGradient);
	DDX_Check(pDX, IDC_VERT_GRADIENT, m_bVertGradient);
	DDX_Text(pDX, IDC_ALPHA_LEVEL, m_AlphaValue);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAlphaChannelOptionsDlg, CDialog)
	//{{AFX_MSG_MAP(CAlphaChannelOptionsDlg)
	ON_BN_CLICKED(IDC_HORZ_GRADIENT, OnHorzGradient)
	ON_BN_CLICKED(IDC_VERT_GRADIENT, OnVertGradient)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_WM_HSCROLL()
	ON_EN_CHANGE(IDC_ALPHA_LEVEL, OnChangeAlphaLevel)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAlphaChannelOptionsDlg message handlers



void CAlphaChannelOptionsDlg::OnHorzGradient() 
{
	OnApply();	
}

void CAlphaChannelOptionsDlg::OnVertGradient() 
{
	OnApply();	
}

void CAlphaChannelOptionsDlg::OnApply() 
{
	if (m_pCardDlg == NULL) {
		return;
	}

	UpdateData(TRUE);

	m_pCardDlg->AlphaOptions.AlphaValue = m_AlphaValue;
	m_pCardDlg->AlphaOptions.bHorzGradient = m_bHorzGradient;
	m_pCardDlg->AlphaOptions.bVertGradient = m_bVertGradient;

//normal
	m_pCardDlg->ApplyAlphaSettings(FALSE);
//	m_pCardDlg->ApplyAlphaSettings(TRUE);
}

BOOL CAlphaChannelOptionsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if (m_pCardDlg != NULL) {
		m_AlphaValue = m_pCardDlg->AlphaOptions.AlphaValue;
		m_bHorzGradient = m_pCardDlg->AlphaOptions.bHorzGradient;
		m_bVertGradient = m_pCardDlg->AlphaOptions.bVertGradient;

		m_AlphaSlider.SetRange(0, 255, TRUE);
		m_AlphaSlider.SetPos(m_AlphaValue);
	}
	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}



void CAlphaChannelOptionsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_AlphaValue = m_AlphaSlider.GetPos();

	UpdateData(FALSE);

	OnApply();
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CAlphaChannelOptionsDlg::OnChangeAlphaLevel() 
{
	OnApply();

}
