// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Tulsa Sample App.h"
#include "MainFrm.h"
#include "SelfTestResults.h"
#include "Tulsa Sample AppView.h"
#include <IStbTulsaCtl.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_COMMAND(ID_VIEW_TIME, OnViewTime)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TIME, OnUpdateViewTime)
	ON_COMMAND(ID_MISC_SELF_TEST_RESULTS, OnMiscSelfTestResults)
	ON_COMMAND(ID_MISC_DEBUG, OnMiscDebug)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_MISC_RESET_ALL, OnMiscResetAll)
	ON_COMMAND(ID_VIEW_AUTO_VIEW, OnViewAutoView)
	ON_UPDATE_COMMAND_UI(ID_VIEW_AUTO_VIEW, OnUpdateViewAutoView)
	ON_WM_TIMER()
	ON_COMMAND(ID_VIEW_POSITION, OnViewPosition)
	ON_UPDATE_COMMAND_UI(ID_VIEW_POSITION, OnUpdateViewPosition)
	ON_COMMAND(ID_VIEW_FRAME, OnViewFrame)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FRAME, OnUpdateViewFrame)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_MISC_STORE_DEBUG_LOG, OnMiscStoreDebugLog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
/////////////////////////////////////////////////////////////////////////////
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_DLLVersion;
	CString	m_I960CodeVersion;
	CString	m_NTDriverVersion;
	CString	m_AppVersion;
	CString	m_BoardVersion;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_DLLVersion = _T("");
	m_I960CodeVersion = _T("");
	m_NTDriverVersion = _T("");
	m_AppVersion = _T("");
	m_BoardVersion = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_DLL_VERSION, m_DLLVersion);
	DDX_Text(pDX, IDC_I960_CODE_VERSION, m_I960CodeVersion);
	DDX_Text(pDX, IDC_NT_DRIVER_VER, m_NTDriverVersion);
	DDX_Text(pDX, IDC_APP_VERSION, m_AppVersion);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CMainFrame::CMainFrame()
{
	m_TimerID = 0;
}

CMainFrame::~CMainFrame()
{
}


/////////////////////////////////////////////////////////////////////////////
// Display the About box 
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnAppAbout() 
{
	CAboutDlg aboutDlg;
	TULSA_BOARD_STATUS CardStatus;
	TULSA_BOARD_VERSION Version;
	CCardDlg* pDlg;


	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();
	int CardNumber = pView->GetCurrentCard();

	if (pDlg = pView->GetCardDialog(CardNumber))
	{
		pDlg->pBoardControl->GetBoardStatus(&CardStatus);
		pDlg->pBoardControl->GetBoardVersion(&Version);
	}
		
	char DLLVer[20];
	char I960CodeVer[20];
	char NTDriverVer[20];
	char AppVer[20];

	sprintf(DLLVer, "%d.%d", (int)(Version.VerDll >> 16), (int)(Version.VerDll & 0xffff));
	sprintf(I960CodeVer, "%d.%d", (int)(Version.VerBoardCode >> 16), (int)(Version.VerBoardCode & 0xffff));
	sprintf(NTDriverVer, "%d.%d", (int)(Version.VerDriver >> 16), (int)(Version.VerDriver & 0xffff));
	sprintf(AppVer, "%d.%d", (int)(VERSION >> 16), (int)(VERSION & 0xffff));

	aboutDlg.m_AppVersion = AppVer;
	aboutDlg.m_DLLVersion = DLLVer;
	aboutDlg.m_I960CodeVersion = I960CodeVer;
	aboutDlg.m_NTDriverVersion = NTDriverVer;

	aboutDlg.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// Display the self-test results for the current card
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnMiscSelfTestResults() 
{
	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();
	int CardNumber = pView->GetCurrentCard();

	CSelfTestResults dlg(CardNumber);
	dlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// Enable the debug monitor mode for the current card
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnMiscDebug() 
{
	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();
	CCardDlg* pDlg;
	if (pDlg = pView->GetCardDialog(pView->GetCurrentCard()))
	{
		pDlg->pDebug->DebugEnterMonitorMode(0);
	}
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::OnMiscResetAll() 
{
	CCardDlg* pDlg;
	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();

	for (int i = 0; i < MAX_STB_TULSA_CARDS; i++) {
		if (tcGuids[i].Data1) {
			pDlg = pView->GetCardDialog(i);
			pDlg->ResetCard();
		}
	}
}

void CMainFrame::StopAutoView()
{
	if (m_TimerID) {
		KillTimer(m_TimerID);
	}
}

void CMainFrame::OnViewAutoView() 
{
	bAutoView = !bAutoView;
	StopAutoView();
	if (bAutoView) {
		m_TimerID = SetTimer(0, 1000, NULL);
	}
}

void CMainFrame::OnUpdateViewAutoView(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(bAutoView);
}

BOOL CMainFrame::DestroyWindow() 
{
	StopAutoView();
	return CFrameWnd::DestroyWindow();
}


void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CFrameWnd::OnTimer(nIDEvent);

	if (bAutoView) {
		CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();
		pView->SetActiveNextCardDialog();
	} else {
		StopAutoView();
	}
}

/////////////////////////////////////////////////////////////////////////////
// Update the playback status units
/////////////////////////////////////////////////////////////////////////////
void CMainFrame::OnViewTime() 
{
	StatusUnits = UNITS_TIME;
}

void CMainFrame::OnUpdateViewTime(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(StatusUnits == UNITS_TIME);
}


void CMainFrame::OnViewPosition() 
{
	StatusUnits = UNITS_POS;	
}

void CMainFrame::OnUpdateViewPosition(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(StatusUnits == UNITS_POS);
}

void CMainFrame::OnViewFrame() 
{
	StatusUnits = UNITS_FRAME;	
}

void CMainFrame::OnUpdateViewFrame(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(StatusUnits == UNITS_FRAME);
}

void CMainFrame::OnMiscTest1() 
{
	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();
	CCardDlg* pDlg;
	if (pDlg = pView->GetCardDialog(pView->GetCurrentCard()))
	{
	}
}

void CMainFrame::OnMiscStoreDebugLog() 
{
	CTulsaSampleAppView *pView = (CTulsaSampleAppView*)GetActiveView();
	CCardDlg* pDlg;
	if (pDlg = pView->GetCardDialog(pView->GetCurrentCard()))
	{
		pDlg->pDebug->DebugStoreLog("LogOutput");
	}
}
